Index: trunk/kernel/kern/process.h
===================================================================
--- trunk/kernel/kern/process.h	(revision 690)
+++ trunk/kernel/kern/process.h	(revision 1)
@@ -1,8 +1,8 @@
 /*
- * process.h - process related functions definition.
- *
+ * process.h - process related management functions
+ * 
  * Authors  Ghassan Almaless (2008,2009,2010,2011,2012)
  *          Mohamed Lamine Karaoui (2015)
- *          Alain Greiner (2016,2017,2018,2019,2020)
+ *          Alain Greiner (2016)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -27,17 +27,14 @@
 #define _PROCESS_H_
 
-#include <kernel_config.h>
+#include <almos_config.h>
 #include <errno.h>
-#include <hal_kernel_types.h>
+#include <hal_types.h>
 #include <list.h>
 #include <xlist.h>
 #include <bits.h>
-#include <busylock.h>
-#include <rwlock.h>
-#include <queuelock.h>
-#include <remote_queuelock.h>
-#include <remote_rwlock.h>
+#include <spinlock.h>
 #include <hal_atomic.h>
 #include <vmm.h>
+#include <signal.h>
 #include <cluster.h>
 #include <vfs.h>
@@ -57,83 +54,29 @@
 
 /*********************************************************************************************
- * This enum defines the actions that can be executed by the process_sigaction() function.
- ********************************************************************************************/
-
-typedef enum 
-{
-    BLOCK_ALL_THREADS    = 0x11,
-    UNBLOCK_ALL_THREADS  = 0x22,
-    DELETE_ALL_THREADS   = 0x33, 
-} 
-process_sigactions_t;
+ * These macros are used to compose or decompose global thread identifier (TRDID)
+ * to or from cluster identifier / local thread index (CXY , LTID)
+ ********************************************************************************************/
+
+#define LTID_FROM_TRDID( trdid )   (ltid_t)(trdid & 0x0000FFFF) 
+#define CXY_FROM_TRDID( trdid )    (cxy_t)(trdid >> 16)
+#define TRDID( cxy , ltid )        (trdid_t)((cxy << 16) | ltid )
 
 /*********************************************************************************************
  * This structure defines an array of extended pointers on the open file descriptors
- * for a given process. The file descriptors are always stored in the same cluster 
- * as the object associated to the file descriptor (inode, socket, pipe, etc). 
- * A free entry in this array contains XPTR_NULL.
- * The array size is defined by the CONFIG_PROCESS_FILE_MAX_NR parameter.
- *
- * NOTE: - Only the fd_array[] in the owner cluster process contains the complete list
- *         of open files, and is protected by the lock against concurrent access.
- *       - the fd_array[] in a process copy is only used to speed the fdid -> xptr
- *         translation, but the "lock" and "max" fields are not significant in these copies.
- *       - The modifications made by the process_fd_register() function are only done
- *         in the owner cluster.
- *       - The modifications made by the process_fd_remove() function are done in the
- *         owner cluster, and in all process_copies.
- *       - In case of miss on a local fd_array, the process_fd_get_xptr() access the
- *         owner cluster fd_array, and update the fd_array local copy.
+ * for a given process. We use an extended pointer because the open file descriptor
+ * is always stored in the same cluster as the inode associated to the file.
+ * A free entry in this array contains the XPTR_NULL value.
+ * The array size is defined by a the CONFIG_PROCESS_FILE_MAX_NR parameter.
+ * All modifications (open/close) must be done by the reference cluster, and reported
  ********************************************************************************************/
 
 typedef struct fd_array_s
 {
-	remote_queuelock_t lock;                              /*! lock protecting fd_array      */
-    uint32_t           max;                               /*! max non-free slot index       */
-	xptr_t             array[CONFIG_PROCESS_FILE_MAX_NR]; /*! open file descriptors         */
+	remote_spinlock_t lock;             /*! lock protecting fd_array[] change.              */
+    uint32_t          current;          /*! current number of open files                    */
+    uint32_t          max;              /*! max number of open files (can be increased)     */
+	xptr_t            array[CONFIG_PROCESS_FILE_MAX_NR];  
 }
 fd_array_t;
-
-/*********************************************************************************************
- * This structure defines the information required by the process_make_exec() function
- * to create a new reference process descriptor, and the associated main thread.
- * All fields in this structure are filled by the sys_exec() function.
- *
- * It contains three parts:
- * - the "path" field is a string defining the pathname of the .elf file.
- * - the "args_pointers" & "args_nr" fields define the arguments (one arg == one string).
- * - the "envs_pointers" & "envs_nr" fields define the env variables (one env == one string).
- *
- * For both the arguments and the environment variables, the array of pointers and the
- * strings themselve are stored in the same kernel buffer. These kernel buffers contain
- * an integer number of contiguous pages, defined by the CONFIG_VMM_ARGS_SIZE and 
- * CONFIG_VMM_ENVS_SIZE parameters respectively.
- * Each kernel (args / envs) buffer contains :
- * - in the first bytes, a fixed size kernel array of pointers on the strings.
- * - in the following bytes, the strings themselves.
- * The size of these arrays of pointers is defined by the CONFIG_PROCESS_ARGS_MAX_NR and
- * CONFIG_PROCESS_ENVS_MAX_NR parameters respectively.
- *
- * WARNING (1) The "args_pointers[i]" & "envs_pointers[i] stored in the dynamically
- *             allocated kernel buffers are local pointers. They must be extended by the
- *             local cluster identifier to compute a valid PPN.
- * WARNING (2) The "args" & "envs" kernel buffers will be mapped to the "args" and "envs"
- *             user vsegs, to be accessed by the new user process. 
- *             The process_make_exec() function must therefore replace the kernel pointers
- *             set by sys_exec(), by user pointers in the new process user space.
- ********************************************************************************************/
-
-typedef struct exec_info_s
-{
-    char           path[CONFIG_VFS_MAX_PATH_LENGTH];  /*! .elf file path in kernel space    */
-
-    char        ** args_pointers;  /*! pointer on array of pointers on strings              */
-    uint32_t       args_nr;        /*! actual number of arguments                           */
-
-    char        ** envs_pointers;  /*! pointer on array of pointers on strings              */
-    uint32_t       envs_nr;        /*! actual number of environment variables               */
-    char         * envs_buf_free;  /*! local pointer on first free slot in strings buffer   */
-}
-exec_info_t;
 
 /*********************************************************************************************
@@ -142,84 +85,99 @@
  * - The PID 16 LSB bits contain the LPID (Local Process Index)
  * - The PID 16 MSB bits contain the owner cluster CXY.
- * In each cluster, the process manager allocates  the LPID values for the process that
- * are owned by this cluster.
- * The process descriptor is replicated in all clusters containing at least one thread 
- * of the PID process, with the following rules :
- * 1) The <pid>, <ppid>, <ref_xp>, <owner_xp>, <vfs_root_xp>, <vfs_bin_xp>  fields are 
- *    defined in all process descriptor copies.
- * 2) The <vfs_cwd_xp> and associated <cwd_lock>, that can be dynamically modified,
- *    are only defined in the reference process descriptor.
- * 2) The <vmm>, containing the VSL (list of registered vsegs), and the GPT (generic
- *    page table), are only complete in the reference process cluster, other copies 
- *    are actually use as read-only caches.
- * 3) the <fd_array>, containing extended pointers on the open file descriptors, is only
- *    complete in the owner process cluster, other copies are read-only caches.
- * 4) The <sem_root>, <mutex_root>, <barrier_root>, <condvar_root>, and the associated
- *    <sync_lock>, dynamically allocated, are only defined in the reference cluster.
- * 5) The <children_root>, <children_nr>, <children_list>, and <txt_list> fields are only
- *    defined in the reference cluster, and are undefined in other clusters.
- * 6) The <local_list>, <copies_list>, <th_tbl>, <th_nr>, <u_th_lock> or <k_th_lock> fields
- *    are specific in each cluster, and are defined in all process descriptors copies.
- * 7) The termination <flags> and <exit_status> are only defined in the reference cluster.
- *    (The term_state format is defined in the shared_syscalls.h file ).
+ * In each cluster, the process manager allocates LPID values for the process that are
+ * allocated to this cluster.
+ * The process descriptor for a PID process is replicated in all clusters containing
+ * at least one thread of the PID process, with some restrictions:
+ * - The list of registered vsegs, the page table (contained in vmm), and the fd_array[]
+ *   are only complete in the reference process descriptor, other copies are read-only caches.
+ * - The following fields are NOT defined in copies other than the reference:
+ *   children_root , children_list , children_nr , sig_mgr
  ********************************************************************************************/
 
 typedef struct process_s
 {
-    vmm_t              vmm;              /*! embedded virtual memory manager                 */
-
-    fd_array_t         fd_array;         /*! embedded open file descriptors array            */
-
-    exec_info_t        exec_info;        /*! embedded structure for args & envs              */
-
-    xptr_t             vfs_root_xp;      /*! extended pointer on VFS root inode              */
-    xptr_t             vfs_bin_xp;       /*! extended pointer on .elf file descriptor        */
-    pid_t              pid;              /*! process identifier                              */
-    xptr_t             ref_xp;           /*! extended pointer on reference process           */
-    xptr_t             owner_xp;         /*! extended pointer on owner process               */
-    xptr_t             parent_xp;        /*! extended pointer on parent process              */
-
-    xptr_t             cwd_xp;           /*! extended pointer on current working dir inode   */
-    remote_busylock_t  cwd_lock;         /*! lock protecting working directory changes       */
-
-    xlist_entry_t      children_root;    /*! root of the children process xlist              */
-    remote_queuelock_t children_lock;    /*! lock protecting children process xlist          */
-    uint32_t           children_nr;      /*! number of children processes                    */
-
-    xlist_entry_t      children_list;    /*! member of list of children of same parent       */
-    xlist_entry_t      local_list;       /*! member of list of process in same cluster       */
-    xlist_entry_t      copies_list;      /*! member of list of copies of same process        */
-    xlist_entry_t      txt_list;         /*! member of list of processes sharing same TXT    */
-
-    struct thread_s  * th_tbl[CONFIG_THREADS_MAX_PER_CLUSTER];       /*! local threads       */
-
-    uint32_t           th_nr;            /*! number of threads in this cluster               */
-    rwlock_t           th_lock;          /*! lock protecting th_tbl[]  i                     */ 
-
-    xlist_entry_t      sem_root;         /*! root of the user defined semaphore list         */
-    xlist_entry_t      mutex_root;       /*! root of the user defined mutex list             */
-    xlist_entry_t      barrier_root;     /*! root of the user defined barrier list           */
-    xlist_entry_t      condvar_root;     /*! root of the user defined condvar list           */
-    remote_queuelock_t sync_lock;        /*! lock protecting user defined synchro lists      */
-
-    xlist_entry_t      dir_root;         /*! root of the user defined DIR list               */
-    remote_queuelock_t dir_lock;         /*! lock protexting user defined DIR list           */
-
-    uint32_t           term_state;       /*! termination status (flags & exit status)        */
+	vmm_t            vmm;               /*! embedded virtual memory manager                 */
+
+	fd_array_t       fd_array;          /*! embedded file descriptors array                 */
+
+	xptr_t           vfs_root_xp;       /*! extende pointer on current file system root     */
+	xptr_t           vfs_cwd_xp;        /*! extended pointer on current working directory   */
+	xptr_t           vfs_bin_xp;        /*! extended pointer on associate .elf file         */
+
+	spinlock_t       cd_lock;           /*! lock protecting working directory changes       */
+ 
+	pid_t            pid;               /*! process identifier                              */
+	pid_t            ppid;              /*! parent process identifier                       */
+	bool_t           is_ref;            /*! this is the reference process if true           */
+    xptr_t           ref_xp;            /*! extended pointer on reference process           */
+
+	xlist_entry_t    children_root;     /*! root of the children process xlist              */
+    uint32_t         children_nr;       /*! number of children processes                    */
+
+	xlist_entry_t    brothers_list;     /*! member of list of children of same parent       */
+
+    list_entry_t     local_list;        /*! member of list of process in same cluster       */
+
+    xlist_entry_t    copies_list;       /*! member of list of copies of same process        */
+
+	spinlock_t       th_lock;           /*! lock protecting th_tbl[] concurrent access      */
+	uint32_t         th_nr;             /*! number of threads in this cluster               */
+
+	struct thread_s * th_tbl[CONFIG_THREAD_MAX_PER_CLUSTER]; /*! pointers on local threads  */
+
+    xlist_entry_t    sem_root;          /*! root of the process semaphores list             */
+    uint32_t         sem_nr;            /*! number of semaphores                            */
+
+	sig_mgr_t        sig_mgr;           /*! embedded signal manager TODO [AG]               */
 }
 process_t;
 
+/*********************************************************************************************
+ * This structure defines the minimal information required by the process_make_exec()
+ * function to build a new reference process descriptor, and the associated main thread.
+ ********************************************************************************************/
+
+typedef struct exec_info_s
+{
+    pid_t              pid;            /*! process identifier                               */
+    pid_t              ppid;           /*! parent process identifier                        */
+
+    xptr_t             fd_array_xp;    /*! extended pointer on parent process fd_array      */
+
+    xptr_t             vfs_root_xp;    /*! extended pointer on file system root             */
+    xptr_t             vfs_cwd_xp;     /*! extended pointer on current working directory    */
+    xptr_t             vfs_bin_xp;     /*! extended pointer on process .elf file            */
+
+    char               path[256];      /*! pathname for  .elf file                          */
+
+    char            ** args_pointers;  /*! physical base address of array of pointers       */
+    char             * args_buf_base;  /*! physical base address of kernel args buffer      */
+    uint32_t           args_nr;        /*! actual number of arguments                       */
+
+    char            ** envs_pointers;  /*! physical base address of array of pointers       */
+    char             * envs_buf_base;  /*! physical base address of kernel args buffer      */
+    char             * envs_buf_free;  /*! physical address of first free slot in envs_buf  */
+    uint32_t           envs_nr;        /*! actual number of environment variables           */
+}
+exec_info_t;
+
+/*********************************************************************************************
+ * This macro returns a pointer on the process descriptor for the calling thread.
+ ********************************************************************************************/
+
+#define CURRENT_PROCESS (hal_get_current_thread()->process)
+
 /***************   Process Descriptor Operations    *****************************************/
 
-/*********************************************************************************************
- * This function allocates memory in local cluster for a process descriptor.
- *********************************************************************************************
+/********************************************************************************************* 
+ * This function allocates memory in local cluster for a process descriptor. 
+ ********************************************************************************************* 
  * @ returns pointer on process descriptor if success / return NULL if failure
  ********************************************************************************************/
-process_t * process_alloc( void );
-
-/*********************************************************************************************
- * This function releases memory in local cluster for a process descriptor.
- *********************************************************************************************
+process_t * process_alloc();
+
+/********************************************************************************************* 
+ * This function releases memory in local cluster for a process descriptor. 
+ ********************************************************************************************* 
  * @ process      : pointer on process descriptor to release.
  ********************************************************************************************/
